#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    int a[n+1];
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
    {
       scanf("%d",&a[i]);
    }
    int q;
    int l;
    int r;
    scanf("%d",&q);
    for(int i=1;i<=q;i++)
    {
        scanf("%d",&l);
        scanf("%d",&r);
        int d=r-l+2;
        int noviniz[d];
        for(int j=1;j<d;j++)
        {
            noviniz[j]=a[l+j-1];
        }
        bool moze =true;
        int br=0;
        for(int i=2;i<d;i++)
        {
            if(noviniz[i]<noviniz[i-1])
            {
                br++;
                if(!(noviniz[i]>=noviniz[i-2]||noviniz[i+1]>=noviniz[i-1]||i==2))
                {
                    moze=false;
                    break;
                }
            }
            if(br>=2)
            {
                moze=false;break;
            }
        }
        if(moze)printf("DA\n");
        else printf("NE\n");
    }
    return 0;
}